/*---------------------------------------------------------------------------
-- JAWAA 2.0 --

Copyright information:

Susan H. Rodger, Pretesh Patel, Ayonike Akingbade, Diana Jackson
Computer Science Department
Duke University
August 2002
Supported by National Science Foundation DUE-9752583.

Copyright (c) 2002
All rights reserved.

Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation,
advertising materials, and other materials related to such
distribution and use acknowledge that the software was developed
by the author.  The name of the author may not be used to
endorse or promote products derived from this software without
specific prior written permission.
THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
File:                           nameoffile.java
Package:                        JAWAA Version 2.0
Author:                         Pretesh Patel, Ayonike Akingbade, Diana Jackson
Date:                           August 2002
Description of Contents:        
                                
--------------------------------------------------------------------------*/
package jawaa.command;

import jawaa.object.JawaaObject;
import java.util.Vector;


public class BeginEndCommand extends JawaaCommand
{
    public BeginEndCommand ()
    {
	super("BeginEnd");
    }

    public void add (Object o)
    {
	myCommands.addElement(o);	
    }

    public void setData ()
    {
	init();
	while (hasNext())
	{
	    Object obj = next();
	    if (obj instanceof JawaaCommand)
	    {
		((JawaaCommand)obj).setData();
	    }
	    else
	    {
		myData.put(((JawaaObject)obj).getName(), obj);
		myCommands.removeElement(obj);
		myIndex--;
	    }
	}
    }

    public boolean step ()
    {
	init();
	while (hasNext())
	{
	    JawaaCommand obj = (JawaaCommand)next();
	    if (! obj.step())
	    {
		myCommands.removeElement(obj);
		myIndex--;
	    }
	}

	return (myCommands.size() != 0);
    }

    private void init ()
    {
	myIndex = 0;
    }

    private boolean hasNext ()
    {
	return myIndex < myCommands.size();
    }

    private Object next ()
    {
	return myCommands.elementAt(myIndex++);
    }


    private Vector myCommands = new Vector();
    private int myIndex = 0;
}
