/*---------------------------------------------------------------------------
-- JAWAA 2.0 --

Copyright information:

Susan H. Rodger, Pretesh Patel, Diana Jackson, Ayonike Akingbade
Computer Science Department
Duke University
August 2002
Supported by National Science Foundation DUE-9752583.

Copyright (c) 2002
All rights reserved.

Redistribution and use in source and binary forms are permitted
provided that the above copyright notice and this paragraph are
duplicated in all such forms and that any documentation,
advertising materials, and other materials related to such
distribution and use acknowledge that the software was developed
by the author.  The name of the author may not be used to
endorse or promote products derived from this software without
specific prior written permission.
THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.

---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------
File:                           nameoffile.java
Package:                        JAWAA Version 2.0
Author:                         Pretesh Patel, Diana Jackson, Ayonike Akingbade
Date:                           August 2002
Description of Contents:        
                                
--------------------------------------------------------------------------*/
package jawaa.object;

import java.awt.*;
import jawaa.util.ColorFactory;


public class JawaaRectangle extends JawaaShape implements Scalable
{
    public JawaaRectangle (String[] args)
    {
	super(args);
    }
    
    public JawaaRectangle(int x, int y,
			  int width, int height,
			  Color color, Color background)
    {
	myLocation = new Point(x, y);
	myWidth = width;
	myHeight = height;
	myColor = color;
	myBackground = background;
    }


    public void build (String[] args) throws
        ArrayIndexOutOfBoundsException, NumberFormatException, Exception
    {
	setLocation(Integer.parseInt(args[2]),
		    Integer.parseInt(args[3]));
	myWidth = Integer.parseInt(args[4]);
	myHeight = Integer.parseInt(args[5]);
	setColor(args[6]);
        // assume same color if they left it off
	setBackground((args.length == 8) ? args[7] : args[6]);
    }


    public void paint (Graphics g)
    {
	if (myBackground.getRGB() != -5544)
	{ 
	    g.setColor(myBackground);
	    g.fillRect(myLocation.x, myLocation.y, myWidth, myHeight);
	}
	if (myColor.getRGB() != -5544)
        {
	    g.setColor(myColor);
	    g.drawRect(myLocation.x, myLocation.y, myWidth, myHeight);
	}
    }
    
    public void setSize (int[] size)
    {
	myWidth = size[0];
	myHeight = size[1];
    }

    public int[] getSize ()
    {
	int[] ret = {myWidth, myHeight};
	return ret;
    }


    protected final String NUMBER_EXCEPTION = "invalid location or dimensions";
}
